<?php
# $Id: geom2wfst.php 2395 2008-04-18 14:46:52Z christoph $
# http://www.mapbender.org/index.php/geom2wfst.php
# Copyright (C) 2002 CCGIS 
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

/**
 * $_REQUEST["url"]
 * $_REQUEST["filter"] 
 */

$wfs_conf_id = $_REQUEST["wfs_conf_id"];
$featuretype_name = $_REQUEST["featuretype_name"];

require_once(dirname(__FILE__)."/../php/mb_validateSession.php");
require_once(dirname(__FILE__)."/../classes/class_mb_exception.php");
require_once(dirname(__FILE__)."/../classes/class_json.php");

function isValidVarName ($varname) {
	if (preg_match("/[\$]{1}_[a-z]+\[\"[a-z_]+\"\]/i", $varname) != 0) {
		return true;
	}
	return false;
}

function addParameterToFilter($filter, $featuretype_name, $wfs_conf_id) {
	
	/* wfs_conf_element */
	$sql = "SELECT * FROM wfs_conf_element ";
	$sql .= "JOIN wfs_element ON wfs_conf_element.f_id = wfs_element.element_id ";
	$sql .= "WHERE wfs_conf_element.fkey_wfs_conf_id = $1 ";
	$sql .= "ORDER BY wfs_conf_element.f_respos";
			
	$v = array($wfs_conf_id);
	$t = array('i');
	$res = db_prep_query($sql,$v,$t);
	while($row = db_fetch_array($res)){
		if (!empty($row["f_auth_varname"])) {
			$auth_varname = $row["f_auth_varname"];
			$element_name = $row["element_name"];
		}
	}
	if (!empty($auth_varname)) {
		$e = new mb_notice("geom2wfst: addParameterToFilter: auth_varname = " . $auth_varname);
		$e = new mb_notice("geom2wfst: addParameterToFilter: element_name = " . $element_name);

		if (isValidVarName($auth_varname)) {
			$user = eval("return " . $auth_varname . ";");
			
			$e = new mb_notice("geom2wfst: addParameterToFilter: user should be " . $_SESSION["mb_user_id"]);
			$e = new mb_notice("geom2wfst: addParameterToFilter: user is " . $user);
			$patternUpdate = "(<wfs:Update[^>]*>)";
			$patternInsert = "(<wfs:Insert[^>]*>)";
			$patternDelete = "(<wfs:Delete[^>]*>)";

			$e = new mb_notice("geom2wfst: addParameterToFilter: old filter was: " . $filter);

			// insert: store authenticated user in database 
			if (eregi($patternInsert, $filter)) {
				$pattern = "(<" . $featuretype_name . ">)";
				$replacement = "\\1<" . $element_name . ">" . $user . "</" . $element_name . ">";
				$filter = eregi_replace($pattern, $replacement, $filter);
			}
			// update or delete: disallow access for other users
			if (eregi($patternDelete, $filter) || eregi($patternUpdate, $filter)) {
				$pattern = "(<ogc:Filter>)(<ogc:FeatureId[^>]*>)(</ogc:filter>)";
				$replacement = "\\1<And>\\2<ogc:PropertyIsEqualTo><ogc:PropertyName>" . $element_name . "</ogc:PropertyName><ogc:Literal>" . $user . "</ogc:Literal></ogc:PropertyIsEqualTo></And>\\3"; 
				$filter = eregi_replace($pattern, $replacement, $filter);
			}
			$e = new mb_notice("geom2wfst: addParameterToFilter: new filter is: " . $filter);
		}
		else {
			$e = new mb_exception("geom2wfst: addParameterToFilter: invalid auth_varname (".$auth_varname.")");
		}
	}
	else {
		$e = new mb_notice("geom2wfst: addParameterToFilter: no auth_varname.");
	}
	return $filter;
			
}
function checkVal($value){
	$pattern = array("'",'"',"--");
	$r = str_replace($pattern, "", $value);	
	$r = addslashes($r);
	return $r;
}


function sepNameSpace($s){
	$c = mb_strpos($s,":"); 
	if($c>0) return mb_substr($s,$c+1);
	return $s;
}
function sendToHost($host,$port,$method,$path,$data){
	$buf = '';
    if (empty($method)) $method = 'POST';
    $method = mb_strtoupper($method);
    $fp = fsockopen($host, $port);
    fputs($fp, "$method $path HTTP/1.1\r\n");
    fputs($fp, "Host: $host\r\n");
    fputs($fp,"Content-type: application/xml\r\n");
    fputs($fp, "Content-length: " . strlen($data) . "\r\n");
    fputs($fp, "Connection: close\r\n\r\n");
    if ($method == 'POST') fputs($fp, $data);
    while (!feof($fp)) $buf .= fgets($fp,4096);
    fclose($fp);
    return $buf;
}

$result="";
$error = false;
$arURL = parse_url($_REQUEST["url"]);
$host = $arURL["host"];
$port = $arURL["port"]; 
if($port == '') $port = 80;	

$path = $arURL["path"];
$method = "POST";
$filter = stripslashes(addParameterToFilter($_REQUEST["filter"], $featuretype_name, $wfs_conf_id));

$data = sendToHost($host,$port,$method,html_entity_decode($path),$filter);

$data = mb_eregi_replace("^[^<]*", "", $data);
$data = mb_eregi_replace("[^>]*$", "", $data);
header('Content-type: text/html');

$resObj = array();
if (mb_strpos(mb_strtoupper($data), "SUCCESS") !== false) {
	$response = "success";
	if (mb_ereg("^.*ogc:FeatureId fid=\"(.+)\"/>.*$", $data)) {
		$fid = mb_ereg_replace("^.*ogc:FeatureId fid=\"(.+)\"/>.*$", "\\1", $data);
		$resObj["fid"] = $fid;
	}
	$resObj["successConfirmation"] = $data;
}
else {
	$response = "error";
	$resObj["errorMessage"] = $data;
}
$resObj["response"] = $response;
$notice = new mb_notice("response:".$response);

header("Content-Type:application/x-json");
$json = new Mapbender_JSON();
echo $json->encode($resObj);
?>