<?php
# $Id: map.php 2886 2008-08-20 14:59:41Z christoph $
# http://www.mapbender.org/index.php/Map.php
# Copyright (C) 2002 CCGIS
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

require_once(dirname(__FILE__)."/../php/mb_validateSession.php");
require_once(dirname(__FILE__)."/../classes/class_wms.php");

// see http://trac.osgeo.org/mapbender/ticket/79
ini_set('session.bug_compat_42',0); 
ini_set('session.bug_compat_warn',0);

/*
// may be added at a later stage
$gui_changed=0;
$new_wmc=0;

if (!$_REQUEST["layer_preview"] && isset($_SESSION["mb_user_gui"]) && $_SESSION["mb_user_gui"] != $_REQUEST["gui_id"]) {
	$gui_changed=1;
}

if (!isset($_SESSION['mb_wmc']) || ($gui_changed==1) ||	($_REQUEST['layer_preview'] && $_REQUEST['portal_services'])) {
	$new_wmc=1;
}

if (isset($_REQUEST['layer_preview']) && $_REQUEST['layer_preview'] != 0) {
	$_SESSION['layer_preview'] = $_REQUEST['portal_services'];
}
else {
	$_SESSION['layer_preview'] = 0;
}
*/
$_SESSION["mb_user_gui"] = $gui_id;

ob_start();
header('Content-type: application/x-javascript');

//
// Define global variables (TODO: move to mapbender object later on)
//
echo "var mb_nr = '".session_id()."';";
echo "var mb_myLogin = '".$_SESSION["mb_login"]."';";
echo "var mb_styleID = '".md5($_SESSION["mb_user_name"])."';";
echo "var mb_myBBOX = '".$_SESSION["mb_myBBOX"]."';";
echo "var mapbender = {};";
echo "mapbender.locale = '" . $_SESSION["mb_locale"] . "';";
echo "mapbender.languageId = '" . $_SESSION["mb_lang"] . "';";
echo "mapbender.versionNumber = '" . MB_VERSION_NUMBER . "';";
echo "mapbender.versionAppendix = '" . MB_VERSION_APPENDIX . "';";
echo "mapbender.releaseDate = new Date(".date("Y",MB_RELEASE_DATE).",".date("n",MB_RELEASE_DATE).",".date("j",MB_RELEASE_DATE).");";
echo "var owsproxy = '".OWSPROXY."';";
echo "var global_mb_log_js = '".LOG_JS."';";
echo "var global_mb_log_level = '".LOG_LEVEL."';";
echo "var global_log_levels = '".LOG_LEVEL_LIST."';";
echo "var mb_feature_count = ".MB_FEATURE_COUNT.";";
echo "var mb_resolution = ".MB_RESOLUTION.";";

//
// Load JavaScript libraries
//
require_once(dirname(__FILE__) . "/../extensions/jquery.js");
require_once(dirname(__FILE__) . "/../javascripts/map.js");
require_once(dirname(__FILE__) . "/../javascripts/point.js");
require_once(dirname(__FILE__) . "/../javascripts/map_obj.js");
require_once(dirname(__FILE__) . "/../javascripts/wfs_obj.js");
require_once(dirname(__FILE__) . "/../extensions/jqjson.js");
require_once(dirname(__FILE__) . "/../javascripts/style.js");

//
// Load WMS
// 
$sql = "SELECT fkey_wms_id FROM gui_wms WHERE fkey_gui_id = $1 ORDER BY gui_wms_position";
$v = array($gui_id);
$t = array('s');
$res = db_prep_query($sql, $v, $t);

while($row = db_fetch_array($res)) {
	$mywms = new wms();
	$mywms->createObjFromDB($gui_id, $row["fkey_wms_id"]);
	$mywms->createJsObjFromWMS();
}

//
// Load JavaScript modules of GUI elements
//
$sql = "SELECT DISTINCT e_mb_mod FROM gui_element WHERE e_public = 1 AND fkey_gui_id = $1";
$v = array($gui_id);
$t = array('s');
$res = db_prep_query($sql, $v, $t);
while($row = db_fetch_array($res)){
	if($row["e_mb_mod"] != ""){
		$moduleArray = explode(",", $row["e_mb_mod"]);
		for ($i = 0; $i < count($moduleArray); $i++) {
			$currentFile = dirname(__FILE__) . "/../javascripts/" . trim($moduleArray[$i]);
			if (file_exists($currentFile)) {
				$e = new mb_notice("LOADING module : " . $currentFile);
				require_once($currentFile);
			}
			else {
				$e = new mb_exception("Javascript module not found: " . $currentFile);
			}
		}
	}
}

//
// Load JavaScript files of GUI elements
//
$mb_sql = "SELECT DISTINCT e_js_file, e_id, e_src, e_target, e_pos, " .
		"e_requires FROM gui_element WHERE e_public = 1 AND " .
		"fkey_gui_id = $1 ORDER BY e_pos";
$mb_v = array($gui_id);
$mb_t = array("s");
$mb_res = db_prep_query($mb_sql, $mb_v, $mb_t);
while($row_js = db_fetch_array($mb_res)){
	if($row_js["e_js_file"] != ""){
		$e_id = $row_js["e_id"];
		$e_src = $row_js["e_src"];
		$e_require = $row_js["e_requires"];
		$e_target = explode(",",$row_js["e_target"]);
		$currentFile = $row_js["e_js_file"];
		if (file_exists($currentFile)) {
			$e = new mb_notice("LOADING Javascript: " . $currentFile . " of element: " . $e_id);
			require_once($currentFile);
		}
		else {
			$e = new mb_exception("Javascript not found: " . $currentFile);
		}
	}
}
?>
