--
-- database changes in version 2.5
--
-- notice language plpgsql has to be installed
-- 

INSERT INTO gui_mb_group (fkey_gui_id, fkey_mb_group_id, mb_group_type) VALUES ('admin_de_services', 20, '');
INSERT INTO gui_mb_group (fkey_gui_id, fkey_mb_group_id, mb_group_type) VALUES ('admin_en_services', 20, '');

--
-- table mb_monitort: new columns for mb_monitor
--
ALTER TABLE mb_monitor ADD COLUMN image int(11);
ALTER TABLE mb_monitor ADD COLUMN map_url varchar(2048);


--
-- WFS database handling
-- enhancement of the datadase structure concerning WFS metadata (same solution like for WMS) 
--
ALTER table wfs add wfs_getcapabilities_doc text;
ALTER table wfs add wfs_upload_url varchar(255);
ALTER table wfs add fees varchar(255);
ALTER table wfs add accessconstraints text;
ALTER table wfs add individualname varchar(255);
ALTER table wfs add positionname varchar(255);
ALTER table wfs add providername varchar(255);
ALTER table wfs add city varchar(255);
ALTER table wfs add deliverypoint varchar(255);
ALTER table wfs add administrativearea varchar(255);
ALTER table wfs add postalcode varchar(255);
ALTER table wfs add voice varchar(255);
ALTER table wfs add facsimile varchar(255);
ALTER table wfs add electronicmailaddress varchar(255);
ALTER table wfs add wfs_mb_getcapabilities_doc text;
ALTER table wfs add wfs_owner int(11);
ALTER table wfs add wfs_timestamp int(11);
ALTER table wfs add country varchar(255);


ALTER TABLE wfs MODIFY wfs_title varchar(255) NOT NULL;
ALTER TABLE wfs ALTER COLUMN wfs_title SET DEFAULT '';

ALTER TABLE wfs MODIFY wfs_version NOT NULL;
ALTER TABLE wfs ALTER COLUMN wfs_version SET DEFAULT '';

ALTER TABLE wfs MODIFY wfs_getcapabilities NOT NULL;
ALTER TABLE wfs ALTER COLUMN wfs_getcapabilities SET DEFAULT '';

alter table wfs_featuretype add column featuretype_searchable integer default 1;
alter table wfs_featuretype add column featuretype_abstract character varying(50);


-- grant root access to default wfs
UPDATE wfs SET wfs_owner = 1;

--
-- new table gui_wfs_conf
--
CREATE TABLE gui_wfs_conf (
    fkey_gui_id character varying(50) DEFAULT '' NOT NULL,
    fkey_wfs_conf_id integer DEFAULT 0 NOT NULL
);

ALTER TABLE gui_wfs_conf
    ADD CONSTRAINT pk_fkey_wfs_conf_id PRIMARY KEY (fkey_gui_id, fkey_wfs_conf_id);
   
ALTER  TABLE gui_wfs_conf
    ADD CONSTRAINT gui_wfs_conf_ibfk_1 FOREIGN KEY (fkey_gui_id) REFERENCES gui(gui_id) ON UPDATE CASCADE ON DELETE CASCADE;
    
ALTER TABLE gui_wfs_conf
    ADD CONSTRAINT gui_wfs_conf_ibfk_2 FOREIGN KEY (fkey_wfs_conf_id) REFERENCES wfs_conf(wfs_conf_id) ON UPDATE CASCADE ON DELETE CASCADE;

-- insert wfs confs into gui digitize
INSERT INTO gui_wfs_conf (fkey_gui_id, fkey_wfs_conf_id) VALUES ('gui_digitize', 1);
INSERT INTO gui_wfs_conf (fkey_gui_id, fkey_wfs_conf_id) VALUES ('gui_digitize', 3);
INSERT INTO gui_wfs_conf (fkey_gui_id, fkey_wfs_conf_id) VALUES ('gui_digitize', 4);
INSERT INTO gui_wfs_conf (fkey_gui_id, fkey_wfs_conf_id) VALUES ('gui_digitize', 2);



--
-- new table wfs_featuretype_keyword: 
--
CREATE TABLE wfs_featuretype_keyword (
  fkey_featuretype_id integer NOT NULL,
  fkey_keyword_id integer NOT NULL
);

ALTER TABLE wfs_featuretype_keyword
    ADD CONSTRAINT fkey_keyword_id_fkey_featuretype_id FOREIGN KEY (fkey_keyword_id) REFERENCES keyword(keyword_id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE wfs_featuretype_keyword
    ADD CONSTRAINT fkey_featuretype_id_fkey_keyword_id FOREIGN KEY (fkey_featuretype_id) REFERENCES wfs_featuretype(featuretype_id) ON UPDATE CASCADE ON DELETE CASCADE;

--
-- new table layer_load_count
--
CREATE TABLE layer_load_count (
 fkey_layer_id int4, 
 load_count int8
);


--
-- table wfs_conf
--
ALTER TABLE wfs_conf add COLUMN wfs_conf_description text;

ALTER TABLE `wfs_conf`
    ADD CONSTRAINT wfs_conf_ibfk_2 FOREIGN KEY (fkey_featuretype_id) REFERENCES wfs_featuretype(featuretype_id) ON UPDATE CASCADE ON DELETE CASCADE;

--
-- table wfs_conf_element: change in WFS configuration: access to geometries may now be restricted
--
ALTER TABLE wfs_conf_element ADD COLUMN f_show_detail int4;
ALTER TABLE wfs_conf_element ADD COLUMN f_operator VARCHAR(50);

--
-- table gui_element: new column for translation
--
-- ALTER TABLE gui_element ADD COLUMN e_title VARCHAR(255) NULL;
INSERT INTO gui_element(fkey_gui_id, e_id, e_pos, e_public, e_comment, e_element, e_src, e_attributes, e_left, e_top, e_width, e_height, e_z_index, e_more_styles, e_content, e_closetag, e_js_file, e_mb_mod, e_target, e_requires, e_url) VALUES('admin1','WFS',2,1,'edit wfs settings','a','','href = "../javascripts/mod_wfs_client.html" target="AdminFrame"',10,1005,250,20,NULL ,'font-family: Arial, Helvetica, sans-serif; font-size : 12px; text-decoration : none; color: #808080;','EDIT WFS','a','','','','AdminFrame','');


--
-- new table layer_load_count
--
CREATE TABLE layer_load_count (
 fkey_layer_id int(11), 
 load_count int(11)
);


-- 
-- new table translation: new table for translations
-- 

 CREATE TABLE translations
 (
   trs_id int(11) NOT NULL auto_increment,
   locale varchar(8),
   msgid varchar(512),
   msgstr varchar(512),
   PRIMARY KEY (trs_id)
 );

 
 CREATE INDEX msgid_idx ON translations(msgid);

-- 
-- new function gettext for easy translations
-- 

-- function has to be translated


--
-- new entries for table translations
--

INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Pan', 'Ausschnitt verschieben');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Display complete map', 'gesamte Karte anzeigen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Zoom in', 'In die Karte hineinzoomen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Zoom out', 'Aus der Karte herauszoomen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Back', 'ZurÃ¼ck');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Forward', 'Nach vorne');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Coordinates', 'Koordinaten anzeigen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Zoom by rectangle', 'Ausschnitt wÃ¤hlen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Redraw', 'Neu laden oder Tastatur: Leertaste');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Query', 'Datenabfrage');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Logout', 'Abmelden');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'WMS preferences', 'WMS Einstellungen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Adding WMS from filtered list', 'WMS von gefilteter Liste hinzufÃ¼gen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Set map center', 'Kartenmittelpunkt setzen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Help', 'Hilfe');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Show WMS infos', 'Anzeige von WMS Informationen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Save workspace as web map context document', 'Ansicht als Web Map Context Dokument speichern');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Resize Mapsize', 'BildschirmgrÃ¶Ãe anpassen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Rubber', 'Skizze lÃ¶schen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Get Area', 'FlÃ¤che berechnen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Close Polygon', 'Polygon schliessen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Move back to your GUI list', 'ZurÃ¼ck zur GUI Liste');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Legend', 'Legende');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Print', 'Druck');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Imprint', 'Impressum');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Maps', 'Karten');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Search', 'Suche');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Meetingpoint', 'Treffpunkt');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Metadatasearch', 'Metadatensuche');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Adding WMS', 'WMS hinzufÃ¼gen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Adding WMS from List', 'WMS aus Liste hinzufÃ¼gen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Info', 'Info');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Change Projection', 'Projektion Ã¤ndern');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Copyright', 'Copyright');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Digitize', 'Digitalisierung');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Overview', 'Ãbersichtskarte');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Drag Mapsize', 'Karte vergrÃ¶Ãern');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Mapframe', 'Kartenfenster');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Navigation Frame', 'Navigationsfenster');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Scale Select', 'Auswahl des MaÃstabes');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Scale Text', 'MaÃstab per Texteingabe');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Scalebar', 'MaÃstabsleiste');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Set Background', 'Hintegrundkarte auswÃ¤hlen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Zoom to Coordinates', 'Zu den Koordinaten zoomen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Change Password', 'Passwort Ã¤ndern');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de', 'Load a web map context document', 'laden eines Web Map Context Dokumentes');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('de ', 'Logo', 'Logo');

INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Pan', 'ÐÑÐµÐ¼ÐµÑÑÐ¸ Ð¾Ð±Ð»Ð°ÑÑÑÐ°');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Display complete map', 'ÐÐ¾ÐºÐ°Ð¶Ð¸ ÑÑÐ»Ð°ÑÐ° ÐºÐ°ÑÑÐ°');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Zoom in', 'ÐÐ¾ÐºÐ°Ð¶Ð¸ ÐºÐ°ÑÑÐ°ÑÐ° Ð² Ð¿Ð¾-ÐµÐ´ÑÑ Ð¼Ð°ÑÐ°Ð±');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Zoom out', 'ÐÐ¾ÐºÐ°Ð¶Ð¸ ÐºÐ°ÑÑÐ°ÑÐ° Ð² Ð¿Ð¾-Ð´ÑÐµÐ±ÐµÐ½ Ð¼Ð°ÑÐ°Ð±');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Back', 'ÐÐ°Ð·Ð°Ð´');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Forward', 'ÐÐ°Ð¿ÑÐµÐ´');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Coordinates', 'ÐÐ¾Ð¾ÑÐ´Ð¸Ð½Ð°ÑÐ¸');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Zoom by rectangle', 'Ð£Ð²ÐµÐ»Ð¸ÑÐ¸ ÐºÐ°ÑÑÐ°ÑÐ° Ð² Ð¸Ð·Ð±ÑÐ°Ð½Ð°ÑÐ° Ð¾Ð±Ð»Ð°ÑÑ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Redraw', 'ÐÑÐµÑÐµÑÑÐ°Ð¹ Ð¸Ð»Ð¸ Ð¾Ñ ÐºÐ»Ð°Ð²Ð¸Ð°ÑÑÑÐ°ÑÐ°: Ð¿ÑÐ°Ð·ÐµÐ½ Ð¸Ð½ÑÐµÑÐ²Ð°Ð»');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Query', 'ÐÑÐ²ÐºÐ° ÐºÑÐ¼ Ð´Ð°Ð½Ð½Ð¸ÑÐµ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Logout', 'ÐÐ·ÑÐ¾Ð´ Ð½Ð° Ð¿Ð¾ÑÑÐµÐ±Ð¸ÑÐµÐ»');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'WMS preferences', 'WMS Ð½Ð°ÑÑÑÐ¾Ð¹ÐºÐ¸');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Adding WMS from filtered list', 'ÐÐ¾Ð±Ð°Ð²Ð¸ WMS Ð¾Ñ Ð¸Ð·Ð±ÑÐ°Ð½ ÑÐ¿Ð¸ÑÑÐº');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Set map center', 'ÐÐ¾ÑÑÐ°Ð²Ð¸ ÑÐµÐ½ÑÑÑ Ð½Ð° ÐºÐ°ÑÑÐ°');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Help', 'ÐÐ¾Ð¼Ð¾Ñ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Show WMS infos', 'ÐÐ¾ÐºÐ°Ð¶Ð¸ WMS Ð¸Ð½ÑÐ¾ÑÐ¼Ð°ÑÐ¸Ñ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Save workspace as web map context document', 'ÐÐ°Ð¿Ð°Ð·Ð¸ ÑÐ°Ð±Ð¾ÑÐ½Ð¸Ñ Ð´Ð¾ÐºÑÐ¼ÐµÐ½Ñ ÐºÐ°ÑÐ¾ Web Map Context Ð´Ð¾ÐºÑÐ¼ÐµÐ½Ñ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Resize Mapsize', 'ÐÐ°Ð¿Ð°ÑÐ½Ð¸ Ð³Ð¾Ð»ÐµÐ¼Ð¸Ð½Ð°ÑÐ° Ð½Ð° ÐºÐ°ÑÑÐ°ÑÐ°');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Rubber', 'ÐÐ·ÑÑÐ¸Ð¹');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Get Area', 'ÐÐ·ÑÐ¸ÑÐ»Ð¸ Ð¿Ð»Ð¾Ñ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Close Polygon', 'ÐÐ°ÑÐ²Ð¾ÑÐ¸ Ð¿Ð¾Ð»Ð¸Ð³Ð¾Ð½');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Move back to your GUI list', 'ÐÐ°Ð·Ð°Ð´ ÐºÑÐ¼ ÑÐ¿Ð¸ÑÑÐºÐ° Ñ Ð¸Ð½ÑÐµÑÑÐµÐ¹ÑÐ¸ (GUI)');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Legend', 'ÐÐµÐ³ÐµÐ½Ð´Ð°');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Print', 'ÐÐµÑÐ°Ñ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Imprint', 'ÐÐ²ÑÐ¾ÑÑÐºÐ¾ ÐºÐ°ÑÐµ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Maps', 'ÐÐ°ÑÑÐ¸');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Search', 'Ð¢ÑÑÑÐµÐ½Ðµ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Meetingpoint', 'ÐÑÑÑÐ¾ Ð½Ð° ÑÑÐµÑÐ°');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Metadatasearch', 'Ð¢ÑÑÑÐµÐ½Ðµ Ð¿Ð¾ Ð¼ÐµÑÐ°Ð´Ð°Ð½Ð½Ð¸');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Adding WMS', 'ÐÐ¾Ð±Ð°Ð²Ð¸ WMS');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Adding WMS from List', 'ÐÐ¾Ð±Ð°Ð²Ð¸ WMS Ð¾Ñ ÑÐ¿Ð¸ÑÑÐº');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Info', 'ÐÐ½ÑÐ¾ÑÐ¼Ð°ÑÐ¸Ñ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Change Projection', 'ÐÑÐ¾Ð¼ÐµÐ½Ð¸ Ð¿ÑÐ¾ÐµÐºÑÐ¸Ñ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Copyright', 'ÐÐ²ÑÐ¾ÑÑÐºÐ¾ Ð¿ÑÐ°Ð²Ð¾');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Digitize', 'ÐÐ¸Ð³Ð¸ÑÐ°Ð»Ð¸Ð·Ð¸ÑÐ°Ð½Ðµ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Overview','ÐÐ±Ð·Ð¾ÑÐ½Ð° ÐºÐ°ÑÑÐ°');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Drag Mapsize', 'ÐÑÐ¾Ð¼ÐµÐ½Ð¸ ÑÐ°Ð·Ð¼ÐµÑÐ° Ð½Ð° ÐºÐ°ÑÑÐ°ÑÐ°');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Mapframe', 'Ð Ð°Ð¼ÐºÐ° Ð½Ð° ÐºÐ°ÑÑÐ°ÑÐ°');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Navigation Frame', 'ÐÐ°Ð²Ð¸Ð³Ð°ÑÐ¸Ð¾Ð½Ð½Ð° ÑÐ°Ð¼ÐºÐ°');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Scale Select', 'ÐÐ·Ð±Ð¾Ñ Ð½Ð° Ð¼Ð°ÑÐ°Ð±');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Scale Text', 'ÐÑÐ²ÐµÐ´Ð¸ Ð¼Ð°ÑÐ°Ð±');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Scalebar', 'ÐÐ°ÑÐ°Ð±Ð½Ð° ÑÐºÐ°Ð»Ð°');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Set Background', 'ÐÐ·Ð±ÐµÑÐ¸ ÑÐ¾Ð½Ð¾Ð²Ð¾ Ð¸Ð·Ð¾Ð±ÑÐ°Ð¶ÐµÐ½Ð¸Ðµ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Zoom to Coordinates', 'ÐÐ¾ÐºÐ°Ð¶Ð¸ ÐºÐ°ÑÑÐ°ÑÐ° Ð¾ÐºÐ¾Ð»Ð¾ Ð¿Ð¾ÑÐ¾ÑÐµÐ½Ð¸ÑÐµ ÐºÐ¾Ð¾ÑÐ´Ð¸Ð½Ð°ÑÐ¸');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Change Password', 'ÐÑÐ¾Ð¼ÐµÐ½Ð¸ Ð¿Ð°ÑÐ¾Ð»Ð°');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Load a web map context document', 'ÐÐ°ÑÐµÐ´Ð¸ Web Map Context Ð´Ð¾ÐºÑÐ¼ÐµÐ½Ñ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Logo', 'Ð¤Ð¸ÑÐ¼ÐµÐ½ Ð·Ð½Ð°Ðº');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('bg', 'Measure distance', 'ÐÐ·Ð¼ÐµÑÐ¸ ÑÐ°Ð·ÑÑÐ¾ÑÐ½Ð¸Ðµ');

INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Pan', 'ÎÎµÏÎ±ÎºÎ¯Î½Î·ÏÎ·');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Display complete map', 'ÎÏÎ¯Î´ÎµÎ¹Î¾Î· Î Î»Î®ÏÎ¿ÏÏ Î§Î¬ÏÏÎ·');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Zoom in', 'Zoom In');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Zoom out', 'Zoom Out');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Back', 'Î Î¯ÏÏ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Forward', 'Î ÏÏÏÎ¸Î¹Î±');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Coordinates', 'Î£ÏÎ½ÏÎµÏÎ±Î³Î¼Î­Î½ÎµÏ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Zoom by rectangle', 'ÎÎ¿ÏÎ¼ Î±ÏÏ Î¿ÏÎ¸Î¿Î³ÏÎ½Î¹Î¿');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Redraw', 'ÎÏÏÏÏÏÏÎ·');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Query', 'ÎÎ­ÏÏÎ·ÏÎ· ÎÎ¼Î²Î±Î´Î¿Ï');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Logout', 'ÎÏÎ¿ÏÏÎ½Î´ÎµÏÎ·');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'WMS preferences', 'ÎÎ»Î»Î¬Î¾ÏÎµ ÏÎ· Î´Î¹Î¬ÏÎ±Î¾Î· ÏÏÎ½ WMS');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Adding WMS from filtered list', 'Î ÏÏÏÎ¸ÎµÏÎ· WMS Î±ÏÏ ÏÎ¿ ÏÎ¹Î»ÏÏÎ±ÏÎ¹ÏÎ¼Î­Î½Î¿ ÎºÎ±ÏÎ¬Î»Î¿Î³Î¿');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Set map center', 'Î¤Î¿ ÎºÎ±Î¸Î¿ÏÎ¹ÏÎ¼Î­Î½Î¿ ÎÎ­Î½ÏÏÎ¿ Î§Î±ÏÏÏÎ½');
INSERT INTO translations (locale, msgid, msgstr) VALUES  ('gr', 'Help', 'ÎÎ¿Î®Î¸ÎµÎ¹Î±');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Save workspace as web map context document', 'Ansicht als Web Map Context Dokument speichern');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Rubber', 'Î¤Î¿ Î»Î¬ÏÏÎ¹ÏÎ¿- Î¤ÏÎ¯ÏÏÎ·Ï');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Close Polygon', 'Î¤Î¿ ÎÎ»ÎµÎ¹ÏÏÏ Î Î¿Î»ÏÎ³ÏÎ½Î¿');
INSERT INTO translations (locale, msgid, msgstr) VALUES ( 'gr', 'Move back to your GUI list', 'Î Î±ÏÎ¿ÏÏÎ¯Î±ÏÎ· ÏÎ¿Ï GUI ÎÎ±ÏÎ±Î»ÏÎ³Î¿Ï');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Print', 'ÎÎºÏÏÏÏÏÎ·');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Maps', ' Î§Î¬ÏÏÎµÏ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Adding WMS', 'Î ÏÏÏÎ¸ÎµÏÎ· WMS');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Adding WMS from List', 'Î ÏÏÏÎ¸ÎµÏÎ· WMS Î±ÏÏ ÏÎ¿Î½ ÎºÎ±ÏÎ¬Î»Î¿Î³Î¿');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Copyright', 'Copyright');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Navigation Frame', 'Navigationsfenster');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Load a web map context document', 'laden eines Web Map Context Dokumentes');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Measure distance', 'ÎÎ­ÏÏÎ·ÏÎ· ÎÏÏÏÏÎ±ÏÎ·Ï');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Meetingpoint', 'Î£Î·Î¼ÎµÎ¯Î¿ Î£ÏÎ½Î¬Î½ÏÎ·ÏÎ·Ï');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Info', 'Î Î»Î·ÏÎ¿ÏÎ¿ÏÎ¯ÎµÏ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Digitize', 'Î¨Î·ÏÎ¹Î¿ÏÎ¿Î¯Î·ÏÎ·');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Change Projection', 'ÎÎ»Î»Î±Î³Î® Î ÏÎ¿Î²Î¿Î»Î®Ï');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Set Background', 'ÎÏÎ¹Î»Î¿Î³Î® Î¦ÏÎ½ÏÎ¿Ï');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Overview', 'Î ÏÎ¿ÎµÏÎ¹ÏÎºÏÏÎ¹ÏÎ·');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Change Password', 'ÎÎ»Î»Î±Î³Î® Î£ÏÎ½Î¸Î·Î¼Î±ÏÎ¹ÎºÎ¿Ï');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Scalebar', 'ÎÎ±Î½ÏÎ½Î±Ï ÎÎ»Î¯Î¼Î±ÎºÎ±Ï');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr ', 'Logo', 'ÎÎ¿Î³ÏÏÏÏÎ¿');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Zoom to Coordinates', 'ÎÏÏÎ¯Î±ÏÎ· ÏÎµ Î£ÏÎ½ÏÎµÏÎ±Î³Î¼Î­Î½ÎµÏ');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Scale Text', 'ÎÎµÎ¯Î¼ÎµÎ½Î¿ ÎÎ»Î¯Î¼Î±ÎºÎ±Ï');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Show WMS infos', 'Î ÏÎ¿Î²Î¿Î»Î® WMS ÏÎ»Î·ÏÎ¿ÏÎ¿ÏÎ¹ÏÎ½');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Legend', 'ÎÎµÎ¶Î¬Î½ÏÎ±');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Search', 'ÎÎ½Î±Î¶Î®ÏÎ·ÏÎ·');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Resize Mapsize', 'ÎÎ»Î»Î±Î³Î® ÎÎµÎ³Î­Î¸Î¿ÏÏ Î§Î¬ÏÏÎ·');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Drag Mapsize', 'ÎÎ»Î»Î±Î³Î® ÎÎµÎ³Î­Î¸Î¿ÏÏ Î§Î¬ÏÏÎ· Î¼Îµ ÎÎ»Î¯ÏÎ¸Î·ÏÎ·');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Mapframe', 'Î Î»Î±Î¯ÏÎ¹Î¿ Î§Î¬ÏÏÎ·');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Get Area', 'Î ÏÎ¿Î²Î¿Î»Î® Î ÎµÏÎ¹Î¿ÏÎ®Ï');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Imprint', 'ÎÏÎ¿ÏÏÏÏÏÎ·');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Scale Select', 'ÎÏÎ¹Î»Î¿Î³Î® ÎÎ»Î¯Î¼Î±ÎºÎ±Ï');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('gr', 'Metadatasearch', 'ÎÎ½Î±Î¶Î®ÏÎ·ÏÎ· ÏÏÎ± Metadata');

INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Pan', 'Selectie verschuiven');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Display complete map', 'Hele kaart tonen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Zoom in', 'Inzoomen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Zoom out', 'Uitzoomen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Back', 'Terug');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Forward', 'Voorwaarts');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Coordinates', 'Koordinaten tonen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Zoom by rectangle', 'Zoom rechthoek-selectie');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Redraw', 'Opfrissen of toetsenbord : spatiebalk');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Query', 'Data opvragen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Logout', 'Afmelden');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'WMS preferences', 'WMS instellingen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Adding WMS from filtered list', 'WMS van gefilterte lijst toevoegen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Set map center', 'Kaartmiddelpunt aangeven');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Help', 'Help');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Show WMS infos', 'Tonen van WMS Informatie');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Save workspace as web map context document', 'zicht als Web map context dokument bewaren');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Resize Mapsize', 'beeldschermgrote aanpassen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Rubber', 'schets verwerpen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Get Area', 'oppervlakte berekenen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Close Polygon', 'Polygoon sluiten');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Move back to your GUI list', 'Terug naar GUI lijst');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Legend', 'Legende');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Print', 'Drukken');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Imprint', 'Impressum');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Maps', 'Kaarten');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Search', 'Zoek');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Meetingpoint', 'Trefpunt');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Metadatasearch', 'Zoeken naar Metadata');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Adding WMS', 'WMS toevoegen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Adding WMS from List', 'WMS uit lijst toevoegen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Info', 'Informatie');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Change Projection', 'Projektie veranderen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Copyright', 'Copyright');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Digitize', 'Digitaliseren');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Overview', 'overzichtskaart');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Drag Mapsize', 'Kaart vergroten');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Mapframe', 'Kaartvenster');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Navigation Frame', 'Navigeervenster');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Scale Select', 'Schaal selecteren');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Scale Text', 'Schaal via tekstingave');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Scalebar', 'Schaalbalk');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Set Background', 'Achtergrond selecteren');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Zoom to Coordinates', 'Naar koordinaten zoomen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Change Password', 'Paswoord wijzigen');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Load a web map context document', 'Laad een Web Map Context Dokument');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Logo', 'Logo');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('nl', 'Measure distance', 'Meet afstand');

INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Pan', 'Sposta dettaglio');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Display complete map', 'Mostra tutta la mappa');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Zoom in', 'Ingrandisci');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Zoom out', 'Riduci');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Back', 'Indietro');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Forward', 'Avanti');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Coordinates', 'Mostra coordinate');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Zoom by rectangle', 'Seleziona dettaglio');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Redraw', 'Ridisegna oppure, da tastiera: spazio');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Query', 'Interroga');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Logout', 'Logout');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'WMS preferences', 'Impostazioni WMS');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Adding WMS from filtered list', 'Aggiungi un WMS da una lista filtrata');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Set map center', 'Fissa il centro della mappa');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Help', 'Aiuto');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Show WMS infos', 'Mostra informazioni sul WMS');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Save workspace as web map context document', 'Salva vista come documento di Web Map Context');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Resize Mapsize', 'Adatta la dimensione della mappa');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Rubber', 'Cancella bozza');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Get Area', 'Calcola area');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Close Polygon', 'Chiudi poligono');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Move back to your GUI list', 'Torna alla lista delle GUI');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Legend', 'Legenda');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Print', 'Stampa');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Imprint', 'Colophon');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Maps', 'Mappe');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Search', 'Cerca');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Meetingpoint', 'Punti di incontro');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Metadatasearch', 'Ricerca metadati');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Adding WMS', 'Aggiungi WMS');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Adding WMS from List', 'Aggiungi WMS da lista');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Info', 'Info');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Change Projection', 'Cambia proiezione');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Copyright', 'Copyright');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Digitize', 'Digitalizza');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Overview', 'Mappa di insieme');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Drag Mapsize', 'Cambia dimensione mappa');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Mapframe', 'Quadro della mappa');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Navigation Frame', 'Quadro di navigazione');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Scale Select', 'Scelta della scala');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Scale Text', 'Scala dei testi');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Scalebar', 'Scala di riferimento');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Set Background', 'Seleziona mappa di sfondo');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Zoom to Coordinates', 'Ingrandisci alle coordinate');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Change Password', 'Cambia password');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Load a web map context document', 'Carica un documento Web Map Context');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Logo', 'Logo');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('it', 'Measure distance', 'Misura distanza');

INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Pan', 'Desplazamiento');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Display complete map', 'Desplazamiento');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Zoom in', 'Zoom +');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Zoom out', 'Zoom -');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Back', 'Zoom previo');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Forward', 'Zoom siguiente');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Coordinates', 'Mostrar coordenadas');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Zoom by rectangle', 'Zoom rectÃ¡ngulo');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Redraw', 'Refrescar');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Query', 'Busqueda de datos');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Logout', 'Terminar');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'WMS preferences', 'Ajuste WMS');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Adding WMS from filtered list', 'Anadir WMS desde lista filtrada');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Set map center', 'Centrar');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Help', 'Ayuda');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Show WMS infos', 'Mostrar informaciÃ³n sobre WMS');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Save workspace as web map context document', 'Guardar vista como fichero Web Map Context');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Resize Mapsize', 'Modificar el tamano de mapa');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Rubber', 'Borrar');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Get Area', 'Calcular area');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Close Polygon', 'Cerrar polÃ­gono');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Move back to your GUI list', 'Volver a la lista WMS');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Legend', 'Leyenda');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Print', 'Imprimir');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Imprint', 'Aviso legal');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Maps', 'Mapas');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Search', 'Busqueda');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Meetingpoint', 'Lugar de reuniÃ³n');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Metadatasearch', 'BÃºsqueda de datos meta');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Adding WMS', 'AÃ±adir WMS');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Adding WMS from List', 'AÃ±adir WMS desde lista');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Info', 'Informacion');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Change Projection', 'Cambiar projecto');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Copyright', 'Copyright');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Digitize', 'DigitalizaciÃ³n');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Overview', 'Mapa de visiÃ³n general');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Drag Mapsize', 'Ampilar vista de mapa');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Mapframe', 'Ventana de mapa');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Navigation Frame', 'Ventana de navigacion');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Scale Select', 'Selecionar escala');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Scale Text', 'Teclar escala');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Scalebar', 'Fraja de escala');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Set Background', 'Poner el fondo');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Zoom to Coordinates', 'Zoom en coordenadas');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Change Password', 'Cambiar clave');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Load a web map context document', 'Cargar un documento de Web Map Context');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Logo', 'Logo');
INSERT INTO translations (locale, msgid, msgstr) VALUES ('es', 'Measure distance', 'Medir distancias');

--
-- new table gui_kml
--
CREATE TABLE gui_kml (
    kml_id int(11) NOT NULL auto_increment,
    fkey_mb_user_id int(11) NOT NULL,
    fkey_gui_id varchar(50) NOT NULL,
    kml_doc text NOT NULL,
    kml_name varchar(64),
    kml_description text,
    kml_timestamp int(11) NOT NULL,
       PRIMARY KEY (kml_id)
);


ALTER TABLE gui_kml
ADD CONSTRAINT gui_kml_fkey_mb_user_id  FOREIGN KEY (fkey_mb_user_id)
REFERENCES mb_user(mb_user_id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE gui_kml
ADD CONSTRAINT gui_kml_id_fkey_gui_id FOREIGN KEY (fkey_gui_id) 
REFERENCES gui(gui_id) MATCH SIMPLE ON UPDATE CASCADE ON DELETE CASCADE;

-- 
-- new SLD table
--

CREATE TABLE sld_user_layer (
    sld_user_layer_id int(11) NOT NULL auto_increment,
    fkey_mb_user_id int(11) NOT NULL default '0',
    fkey_layer_id int(11) NOT NULL default '0',
    fkey_gui_id varchar(50) NOT NULL default '',
    sld_xml text,
    use_sld tinyint(1) default '0',
    PRIMARY KEY (sld_user_layer_id)
) TYPE=InnoDB;



-- constraints for new table sld_user_layer
ALTER TABLE sld_user_layer ADD CONSTRAINT sld_user_layer_ibfk1 FOREIGN KEY (fkey_mb_user_id) REFERENCES mb_user (mb_user_id) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE sld_user_layer ADD CONSTRAINT ADD CONSTRAINT sld_user_layer_ibfk2 FOREIGN KEY (fkey_layer_id) REFERENCES layer (layer_id) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE sld_user_layer ADD CONSTRAINT ADD CONSTRAINT sld_user_layer_ibfk3 FOREIGN KEY (fkey_gui_id) REFERENCES gui (gui_id) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- add sld related columns
--

ALTER TABLE gui_wms ADD COLUMN gui_wms_sldurl varchar(255) NOT NULL default '';
ALTER TABLE wms ADD COLUMN wms_supportsld boolean NULL;
ALTER TABLE wms ADD COLUMN wms_userlayer boolean NULL;
ALTER TABLE wms ADD COLUMN wms_userstyle boolean NULL;
ALTER TABLE wms ADD COLUMN wms_remotewfs boolean NULL;


--
-- opacity handeling
--

ALTER TABLE gui_wms ADD COLUMN gui_wms_opacity INT DEFAULT 100;

UPDATE gui_element SET e_mb_mod = 'mod_addWMSgeneralFunctions.js' WHERE e_id = 'addWMS';
ALTER TABLE gui_element MODIFY e_js_file character varying(255);
ALTER TABLE gui_element MODIFY e_mb_mod character varying(255);

ALTER TABLE wms MODIFY fees text;
ALTER TABLE wms CHANGE COLUMN wms_mb_getcapabilies_doc wms_mb_getcapabilities_doc text;